package mstparser;

class Morphology {
	int lemma;
	int[] id;
	int[] val;
	
	public Morphology() {
		lemma = -1;
		id = null;
		val = null;
	}
}

class CatibMorphology {
	int dtPos;
	int fgen;
	int fnum;
	int rat;
	boolean dt;

	public CatibMorphology() {
		dtPos = 0;
		fgen = 0;
		fnum = 0;
		rat = 0;
		dt = false;
	}
}

enum SpecialPos {
	C, P, PNX, V, AJ, N, OTHER
}

public class DependencyInstance {

    public int[] sentence;
    public int[] pos;
	public int[] posA;
    public int[] labs;
    public Morphology[] m;
    public CatibMorphology[] cm;
    public FeatureVector fv;
    public String actParseTree;
    public int length;
    public int id;
	public int[] dep;
	public int[][] child;
	public int[] st;
	public int[] en;
	public SpecialPos[] specialPos;		// special POS
	public String[] origWord;		// store the original word string for output
	
	public int[] isNonproj;		// if the dependency is non-proj
	
	public int[] parserPredDep;				// record parser prediction
	public int[] parserPredLab;
	public LocalFeatureData parserPredScore;
	
	public double parserRerankScore;		// only for reranking
	
	public int[][] candPos;					// only for pos correction
	public int[][] candCpos;
	public SpecialPos[][] candSpecialPos;
	public int[] goldPos;
	public int[] currPosCandID;
    
    public DependencyInstance() {}
    
    public DependencyInstance(int length) { this.length = length; }
    
    public DependencyInstance(int[] sentence, FeatureVector fv) {
	this.sentence = sentence;
	this.fv = fv;
	this.length = sentence.length;
    }
    
    public DependencyInstance(int[] sentence, int[] pos, FeatureVector fv) {
	this.sentence = sentence;
	this.pos = pos;
	this.fv = fv;
	this.length = sentence.length;
    }
    
    public DependencyInstance(int[] sentence, int[] pos, int[] labs, Morphology[] m, FeatureVector fv) {
	this.sentence = sentence;
	this.pos = pos;
	this.labs = labs;
	this.m = m;
	this.fv = fv;
	this.length = sentence.length;
    }
    
}
