package mstparser;

public class GlobalFeatureData {
    public int len;
    public int type;

    public int[][] dep2id;					// map a possible dep to an id
    public int maxid;
    public boolean[][] cand;

    public int RB;
    
    public static int maxChildNum = 5;
    public FeatureVector[][][] fvs_cn;	// [len][leftNum][rightNum]
    public double[][][] probs_cn;
    
    public static int maxBinLength = 5;
    public FeatureVector[][][][] fvs_heavy;	// [len][end][punc][bin]
    public double[][][][] probs_heavy;
    
    public FeatureVector[][][] fvs_nb;		// [len][cpos][cpos
    public double[][][] probs_nb;
    
    public static int maxLenDiff = 4;
    public FeatureVector[][][] fvs_cc3;		// [len][len][diff]
    public double[][][] probs_cc3;
    
    public FeatureVector[][][] fvs_ccChild;	// [len][len][same]
    public double[][][] probs_ccChild;
    
    public GlobalFeatureData(LocalFeatureData lfd, int cposNum) {
    	len = lfd.len;
    	type = lfd.type;
    	dep2id = lfd.dep2id;
    	maxid = lfd.maxid;
    	cand = lfd.cand;
    	RB = -1;
    	
    	if (DependencyParser.useGlobal) {
	    	fvs_cn = new FeatureVector[len][maxChildNum + 1][maxChildNum + 1];
	    	probs_cn = new double[len][maxChildNum + 1][maxChildNum + 1];
	    	
	    	fvs_heavy = new FeatureVector[len][2][2][maxBinLength + 1];
	    	probs_heavy = new double[len][2][2][maxBinLength + 1];
	    	
	    	fvs_nb = new FeatureVector[len][cposNum][cposNum] ;
	    	probs_nb = new double[len][cposNum][cposNum];
	    	
	    	fvs_cc3 = new FeatureVector[len][len][maxLenDiff + 1];
	    	probs_cc3 = new double[len][len][maxLenDiff + 1];
	    	
	    	fvs_ccChild = new FeatureVector[len][len][2];
	    	probs_ccChild = new double[len][len][2];
    	}
    }
}
